#ifndef INCLUDE_H_JAVAVMCALLBACK
#define INCLUDE_H_JAVAVMCALLBACK

class JVMEventListener
{
public:
	virtual ~JVMEventListener() {}

	virtual void notifyLibraryLoadFailure( const std::string& v_dllPath ) = 0;

	virtual void notifyJVMStarted() = 0;
	virtual void notifyJVMExited( int v_exitCode ) = 0;
	virtual void notifyJVMAborted() = 0;

	virtual void notifyException( const std::string& v_target ) = 0;
	virtual int notifyJVMLog( FILE* v_fp, const char* v_format, va_list v_args ) = 0;

	virtual void notifyJVMThreadNormalyTerminated( const std::string& v_target ) = 0;
	virtual void notifyJVMThreadAbnomalTerminated( const std::string& v_target, const std::string& v_reason ) = 0;
};

struct JavaVMCallback
{
public:
	JavaVMCallback();

	/*!
	 * Cu[h̎sʒm܂B
	 */
	void (__stdcall *onJVMNotifyPreloadLibFailure)( const char* v_libpath );

	/*!
	 * JavaVMNCNXĂяoOɃR[obN܂B
	 */
	void (__stdcall *onJVMStarted)();

	/*!
	 * CNX̃C\bhIƃR[obN܂B
	 * JVMŖIexit܂abortꂽꍇ͌Ăяo܂B
	 */
	void (__stdcall *onJVMNormalExit)();

	/*!
	 * JVMŖIexitꂽꍇɌĂяo܂B
	 * ͕ԂexitKv܂B
	 */
	void (__stdcall *onJVMExit)( jint );

	/*!
	 * JVMabortꂽꍇɌĂяo܂B
	 * ͕ԂabortKv܂B
	 */
	void (__stdcall *onJVMAbort)();

	/*!
	 * JVMbZ[Wo͂邽тɌĂяo܂B
	 * \param v_fp o͐
	 * \param v_format tH[}bg
	 * \param v_args Xg
	 * \return ݕ
	 */
	jint (__stdcall *onJVMVfprintf)(FILE* v_fp, const char* v_format, va_list v_args);

	/*!
	 * ObZ[Wʒm܂B
	 * \param bZ[W
	 */
	void (__stdcall *onJVMNotifyException)( const char* v_message );

	/*!
	 * XbhُIƂ܂B
	 * \param bZ[W
	 */
	void (__stdcall *onJVMThreadAbnormalTerminated)( const char* v_message );

	/*!
	 * XbhIƂ܂B
	 * \param bZ[W
	 */
	void (__stdcall *onJVMThreadNormalyTerminated)( const char* v_message );

};

#endif
